#!/usr/bin/perl

# TODO: If gammastep is already running, allow location to update

use strict;
use warnings;

use LWP::UserAgent;
use JSON::XS;

my $location = "https://papillon.john.me.tz/data/location.json";
my $lat_lon = fetch_lat_lon($location);

my $pid = fork;
unless ($pid) {
        open STDIN,  '/dev/null';
        open STDOUT, '>>/dev/null';
        open STDERR, '>>/dev/null';

        `gammastep -l $lat_lon`;
}

sub fetch_lat_lon
{
        my ($location) = shift;

	my $ua = LWP::UserAgent->new();
	my $json = JSON::XS->new();

        my $raw = $ua->get($location)->content();

        if (defined $raw) {
		print($raw."\n");
                my $decoded = $json->decode($raw);
                if (defined $decoded->{lat} && defined $decoded->{lon}) {
                        return "$decoded->{lat}:$decoded->{lon}";
                }
                print $decoded->{lat};

        }
        sleep 5;
        return fetch_lat_lon($ua, $json, $location);
}

exit;
